# WelcomeToZembraAPIDocumentation

Zembra provides a RESTful API that supports common HTTP verbs and returns JSON-formatted responses with common HTTP status codes. &lt;br&gt;&lt;br&gt;You can use the sandbox token and endpoints for testing. The sandbox environment is isolated and will not impact your account balance. Nevertheless, the same rate limiting applies to both live and sandbox environments combined. The sandbox randomly returns dummy data representing all different expected responses from an endpoint. The sandbox performs the same set of validation the live box does, including slug validation and eligibility for services. &lt;br&gt;&lt;br&gt;Default rate limiting is set to **100** requests per minute. This limit may vary based on your account settings. If unsure, contact your account manager or reach out to our [support team](mailto:contact@zembratech.com). &lt;br&gt;&lt;br&gt;Each response returned by the API has rate limiting info added to the headers: - **X-RateLimit-Limit**: 100 or -1 if no limit. &lt;br&gt;The allocated rate limit to the account. - **X-RateLimit-Remaining**: &lt; 100 or -1 if no limit. &lt;br&gt;The number of remaining calls before hitting the rate limiting limit and start getting calls rejected until the counter is reset.  Zembra has made SDKs available in many coding languages to help you quickly get started consuming the API with minimum effort: - [C-Sharp](https://cdn.sdks.zembratech.com/zembra-sdk-csharp.zip) - [Elixir](https://cdn.sdks.zembratech.com/zembra-sdk-elixir.zip) - [Go](https://cdn.sdks.zembratech.com/zembra-sdk-go.zip) - [Java](https://cdn.sdks.zembratech.com/zembra-sdk-java.zip) - [Javascript](https://cdn.sdks.zembratech.com/zembra-sdk-javascript.zip) - [Kotlin](https://cdn.sdks.zembratech.com/zembra-sdk-kotlin.zip) - [PHP](https://cdn.sdks.zembratech.com/zembra-sdk-php.zip) - [Python](https://cdn.sdks.zembratech.com/zembra-sdk-python.zip) - [Ruby on Rails](https://cdn.sdks.zembratech.com/zembra-sdk-ruby-on-rails.zip) - [Scala](https://cdn.sdks.zembratech.com/zembra-sdk-scala-akka.zip) - [Swift 5](https://cdn.sdks.zembratech.com/zembra-sdk-swift5.zip) - [Typescript](https://cdn.sdks.zembratech.com/zembra-sdk-typescript.zip)  You can also download [Postman](https://www.postman.com/downloads/) then import this [collection](https://cdn.sdks.zembratech.com/zembra-postman-collection.json) which includes calls the all Zembra API sandbox endpoints with a combination of all available parameters. 

## Building

To install the required dependencies and to build the elixir project, run:

```console
mix local.hex --force
mix do deps.get, compile
```

## Installation

If [available in Hex][], the package can be installed by adding `welcome_to_zembra_api_documentation` to
your list of dependencies in `mix.exs`:

```elixir
def deps do
  [{:welcome_to_zembra_api_documentation, "~> 1.0.0"}]
end
```

Documentation can be generated with [ExDoc][] and published on [HexDocs][]. Once published, the docs can be found at
[https://hexdocs.pm/welcome_to_zembra_api_documentation][docs].

## Configuration

You can override the URL of your server (e.g. if you have a separate development and production server in your
configuration files).

```elixir
config :welcome_to_zembra_api_documentation, base_url: "https://api.zembra.io"
```

Multiple clients for the same API with different URLs can be created passing different `base_url`s when calling
`WelcomeToZembraAPIDocumentation.Connection.new/1`:

```elixir
client = WelcomeToZembraAPIDocumentation.Connection.new(base_url: "https://api.zembra.io")
```

[exdoc]: https://github.com/elixir-lang/ex_doc
[hexdocs]: https://hexdocs.pm
[available in hex]: https://hex.pm/docs/publish
[docs]: https://hexdocs.pm/welcome_to_zembra_api_documentation
