# NOTE: This file is auto generated by OpenAPI Generator 7.13.0-SNAPSHOT (https://openapi-generator.tech).
# Do not edit this file manually.

defmodule WelcomeToZembraAPIDocumentation.Api.Accommodation do
  @moduledoc """
  API calls for all endpoints tagged `Accommodation`.
  """

  alias WelcomeToZembraAPIDocumentation.Connection
  import WelcomeToZembraAPIDocumentation.RequestBuilder

  @doc """
  Get Property Details by ID
  Returns the list of available properties and their prices by ids. If the property is sold out, is closed, has a minimum stay policy, or requires more rooms to fit the requested number of guests, it is likely that the selected date range will not return result. The cost of this service is 125 credits per 625 properties and limited to 5,000 property ids per request.

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `network` ([WelcomeToZembraAPIDocumentation.Model.AccommodationNetwork.t]): The network to be queried using the ids.
  - `get_property_details_by_id_request` (GetPropertyDetailsByIdRequest): 
  - `opts` (keyword): Optional parameters

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsById200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec get_property_details_by_id(Tesla.Env.client, list(WelcomeToZembraAPIDocumentation.Model.AccommodationNetwork.t), WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByIdRequest.t, keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName402Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsById200Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName400Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response.t} | {:error, Tesla.Env.t}
  def get_property_details_by_id(connection, network, get_property_details_by_id_request, _opts \\ []) do
    request =
      %{}
      |> method(:post)
      |> url("/accommodations/fetch/#{network}")
      |> add_param(:body, :body, get_property_details_by_id_request)
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsById200Response},
      {400, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName400Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response},
      {402, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName402Response},
      {403, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response}
    ])
  end

  @doc """
  Get Property Details by Name
  Returns the list of available properties and their prices. The cost of this service is 125 credits for the first network + 100 credits per additional network.

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `search_string` (String.t): The location/region of the targetted properties
  - `checkin` (Date.t): The check-in date in 'yyyy-mm-dd' to be used in the search.
  - `checkout` (Date.t): The check-out date in 'yyyy-mm-dd' to be used in the search.
  - `rooms` ([WelcomeToZembraAPIDocumentation.Model.RoomsInner.t]): The list of rooms including the number of adults and the list of children ages.
  - `opts` (keyword): Optional parameters
    - `:"networks[]"` ([WelcomeToZembraAPIDocumentation.Model.AccommodationNetwork.t]): Optional field to restrict the search query to a limited set of networks. If omitted, the search covers all networks enabled for the account and supported by this service.
    - `:targetCountry` (String.t): The country from which the query will be issued. Simulating a user search from this country. If no country is provided, a random country will be selected. The format must be in ISO 3166-1 alpha-2.
    - `:currency` (String.t): The currency used for the returned prices. The format must be in ISO 4217 three-letter code. If the currency is invalid, the returned price will be in property's local currency. If omitted, USD will be used as default currency.
    - `:latitude` (float()): Some search query strings may return more than one matching locations. To ensure referencing the desired location, you can provide the coordinate of the target search location. Either both latitude and longitude are provided or both must be omitted.
    - `:longitude` (float()): Some search query strings may return more than one matching locations. To ensure referencing the desired geolocation you can provide its coordinates. Either both latitude and longitude are provided or both must be omitted.

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec get_property_details_by_name(Tesla.Env.client, String.t, Date.t, Date.t, list(WelcomeToZembraAPIDocumentation.Model.RoomsInner.t), keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName402Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName200Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName400Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName404Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response.t} | {:error, Tesla.Env.t}
  def get_property_details_by_name(connection, search_string, checkin, checkout, rooms, opts \\ []) do
    optional_params = %{
      :"networks[]" => :query,
      :targetCountry => :query,
      :currency => :query,
      :latitude => :query,
      :longitude => :query
    }

    request =
      %{}
      |> method(:get)
      |> url("/accommodations/lookup")
      |> add_param(:query, :searchString, search_string)
      |> add_param(:query, :checkin, checkin)
      |> add_param(:query, :checkout, checkout)
      |> add_param(:query, :rooms, rooms)
      |> add_optional_params(optional_params, opts)
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName200Response},
      {400, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName400Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response},
      {402, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName402Response},
      {403, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response},
      {404, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName404Response}
    ])
  end

  @doc """
  Get Property Pricing by Date Range
  Returns the list of prices for the given property for each of the requested dates if the property is available. If the property is sold out, is closed, has a minimum stay policy, or requires more rooms to fit the requested number of guests, it is likely that the selected date range will not return result. The cost of this service is 100 credits and limited to 500 date ranges per request.

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `network` ([WelcomeToZembraAPIDocumentation.Model.AccommodationNetwork.t]): The network to be queried using the property id.
  - `property_id` (integer()): The id of the property is it defined on the target network.
  - `get_property_pricing_by_date_range_request` (GetPropertyPricingByDateRangeRequest): 
  - `opts` (keyword): Optional parameters

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyPricingByDateRange200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec get_property_pricing_by_date_range(Tesla.Env.client, list(WelcomeToZembraAPIDocumentation.Model.AccommodationNetwork.t), integer(), WelcomeToZembraAPIDocumentation.Model.GetPropertyPricingByDateRangeRequest.t, keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName402Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName400Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyPricingByDateRange200Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyPricingByDateRange404Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response.t} | {:error, Tesla.Env.t}
  def get_property_pricing_by_date_range(connection, network, property_id, get_property_pricing_by_date_range_request, _opts \\ []) do
    request =
      %{}
      |> method(:post)
      |> url("/accommodations/fetch/#{network}/#{property_id}")
      |> add_param(:body, :body, get_property_pricing_by_date_range_request)
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.GetPropertyPricingByDateRange200Response},
      {400, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName400Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response},
      {402, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName402Response},
      {403, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response},
      {404, WelcomeToZembraAPIDocumentation.Model.GetPropertyPricingByDateRange404Response}
    ])
  end
end
