# NOTE: This file is auto generated by OpenAPI Generator 7.13.0-SNAPSHOT (https://openapi-generator.tech).
# Do not edit this file manually.

defmodule WelcomeToZembraAPIDocumentation.Api.Reviews do
  @moduledoc """
  API calls for all endpoints tagged `Reviews`.
  """

  alias WelcomeToZembraAPIDocumentation.Connection
  import WelcomeToZembraAPIDocumentation.RequestBuilder

  @doc """
  Create Review Job
  Creates a new job to pull review data from the requested review page. The response will also include the listing's information. <br><br>You can set your preferred level of monitoring: <ul> <li><strong>None</strong> (default): This means that monitoring will not be enabled, i.e. reviews will not maintained up to date. We will return a fresh snapshot of the reviews without sourcing from our cached data. Data retention is set to 5 days. The cost per job is 50 credits + 1 credit per returned review. With this type of monitoring, you can set a <code>sizeLimit</code> and/or <code>dateLimit</code> (whichever comes first) to limit the number of returned reviews and consequently the cost. This type of jobs cannot be set for auto-renewal.</li> <li><strong>Basic</strong>: All the reviews are immediately made available once crawling is completed. Updates and fetching of new reviews is once every 30 days. The cost of this type of jobs is 75 credits + 3 credits per returned review. You can set this job to auto-renew. The cost of an auto-renewed job is 50 credits + 3 credits per returned <u>new</u> reviews. You do not get charged twice for an existing and previously returned review. You cannot set limits of any kind on this type of jobs. The original listing although it is included in the response, it is not guaranteed to be up to date. Edits, replies, deletions, restorations, and any changes affecting existing reviews are not guaranteed to be applied. The main purpose of this monitoring style is to ensure collecting new reviews on a monthly basis. This job remains active for 30 days.</li> <li><strong>Regular</strong>: All the reviews are immediately made available once crawling is completed. Updates and fetching of new reviews is once a day. The cost of this type of jobs is 125 credits + 3 credits per returned review. You can set this job to auto-renew. The cost of an auto-renewed job is 75 credits + 3 credits per returned <u>new</u> reviews. You do not get charged twice for an existing and previously returned review. You cannot set limits of any kind on this type of jobs. The original listing although it is included in the response, it is not guaranteed to be up to date. Edits, replies, deletions, restorations, and any changes affecting existing reviews are not guaranteed to be applied. The main purpose of this monitoring style is to ensure collecting new reviews on a daily basis. This job remains active for 30 days.</li> <li><strong>Full</strong>: The recommended monitoring level for online reputation management activities. The initial pull is processed through a priority queue to ensure minimum delay before delivery. Updates and fetching of new reviews are as frequent as the activity on the target listing with a guarantee of a maximum rest time of 8-12 hours (depends on the platform). The cost of this type of jobs is 150 credits + 1 credit per returned review. You can set this job to auto-renew. The cost of an auto-renewed job is 100 credits + 1 credit per returned reviews. You will be charged for all the reviews in each cycle because we are closely monitoring all the reviews. You will also receive updates for any affected existing review regardless of when it was initially pulled. You cannot set limits of any kind on this type of jobs. The original listing is kept up to date. This job remains active for 30 days.</li> </ul> Please note that all jobs with any kind of monitoring enabled will cause the pull of the entire set of reviews. Having a track of the reviews is crucial for our monitoring and collision detection process. <br>All monitoring jobs remain valid for 30 days. If you desire to change the monitoring level, you must cancel the existing job then create a new job with the new monitoring level. You will lose all the previous data and you will be charged again for the new job independently from the history. <br>There cannot be two active jobs with monitoring enabled. If you use a different slug for the same listing it will result in the same job being returned and no new job will be created. <br><br>The review fetching starts promptly after creation and data is made available a few seconds later. <br>If you have an endpoint listening to our webhook callback, expect the signal to be issued within a few seconds from the original request. 

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `create_review_job_request` (CreateReviewJobRequest): 
  - `opts` (keyword): Optional parameters

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.CreateReviewJob200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec create_review_job(Tesla.Env.client, WelcomeToZembraAPIDocumentation.Model.CreateReviewJobRequest.t, keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName402Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetListingDetails400Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.CreateReviewJob200Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.CreateReviewJob404Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response.t} | {:error, Tesla.Env.t}
  def create_review_job(connection, create_review_job_request, _opts \\ []) do
    request =
      %{}
      |> method(:post)
      |> url("/reviews")
      |> add_param(:body, :body, create_review_job_request)
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.CreateReviewJob200Response},
      {400, WelcomeToZembraAPIDocumentation.Model.GetListingDetails400Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response},
      {402, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName402Response},
      {403, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response},
      {404, WelcomeToZembraAPIDocumentation.Model.CreateReviewJob404Response}
    ])
  end

  @doc """
  Delete Review Job
  Completely delete a job. This action is not reversible. In the scenario you re-request to create a job for the same review page, you will be charged a new fee like if the previous and deleted job had never existed. You will also immediately stop receiving updates. We will stop monitoring changes.

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `uid` (String.t): The UID of the listing that was returned at the time of creation. It persists over time and across accounts. This field is required if `jobId` and `network` + `slug` are missing.
  - `opts` (keyword): Optional parameters
    - `:network` (ReviewNetwork): Network this listing belongs to. This field is required if `jobId` and `uid` are missing and must be associated with field `slug`.
    - `:slug` (String.t): The slug associated with the listing. Using variants of the same slug might cause the API to return 404 Not Found if we do not have track of the alias. This field is required if `jobId` and `uid` are missing and must be associated with field `network`.
    - `:jobId` (String.t): The ID of the job that was returned at the time of creating the job. This field is required if `uid` and `network` + `slug` are missing.

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.DeleteReviewJob200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec delete_review_job(Tesla.Env.client, String.t, keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.DeleteReviewJob404Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.DeleteReviewJob200Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.DeleteReviewJob400Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response.t} | {:error, Tesla.Env.t}
  def delete_review_job(connection, uid, opts \\ []) do
    optional_params = %{
      :network => :query,
      :slug => :query,
      :jobId => :query
    }

    request =
      %{}
      |> method(:delete)
      |> url("/reviews")
      |> add_param(:query, :uid, uid)
      |> add_optional_params(optional_params, opts)
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.DeleteReviewJob200Response},
      {400, WelcomeToZembraAPIDocumentation.Model.DeleteReviewJob400Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response},
      {403, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response},
      {404, WelcomeToZembraAPIDocumentation.Model.DeleteReviewJob404Response}
    ])
  end

  @doc """
  Trigger Reviews Fetch
  Schedules an instant fetch job to pull reviews updates. The job is executed immediately. This helps instructing our engines to fetch reviews and return all new reviews and changes without waiting until the next scheduled crawl. <br><br>By default, we pull updates for recent reviews only, i.e. `partial`. A minimum wait time of 1 minute has to observed before requesting to fetch reviews again. For full scans, the minimum wait time is 5 minutes. 

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `fetch_reviews_request` (FetchReviewsRequest): 
  - `opts` (keyword): Optional parameters

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.FetchReviews200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec fetch_reviews(Tesla.Env.client, WelcomeToZembraAPIDocumentation.Model.FetchReviewsRequest.t, keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.FetchReviews200Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.FetchReviews404Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.FetchReviews400Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response.t} | {:error, Tesla.Env.t}
  def fetch_reviews(connection, fetch_reviews_request, _opts \\ []) do
    request =
      %{}
      |> method(:put)
      |> url("/reviews")
      |> add_param(:body, :body, fetch_reviews_request)
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.FetchReviews200Response},
      {400, WelcomeToZembraAPIDocumentation.Model.FetchReviews400Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response},
      {403, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response},
      {404, WelcomeToZembraAPIDocumentation.Model.FetchReviews404Response}
    ])
  end

  @doc """
  Get Reviews
  Returns the list of reviews that were collected as requested in the review job. To retrieve a job, you must specify the `jobId`, `uid`, or the pair of `network` and `slug`. At least one of these params must be present in order to identify the record locally but not all. If you use the pair of `network` and `slug` then we will try to return the active monitoring job. If there is no job with monitoring enabled then we will return the most recent job without monitoring.

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `opts` (keyword): Optional parameters
    - `:network` (ReviewNetwork): Network this listing belongs to. This field is required if `jobId` and `uid` are missing and must be associated with field `slug`.
    - `:slug` (String.t): The slug associated with the listing. Using variants of the same slug might cause the API to return 404 Not Found if we do not have track of the alias. This field is required if `jobId` and `uid` are missing and must be associated with field `network`.
    - `:jobId` (String.t): The ID of the job that was returned at the time of creating the job. This field is required if `uid` and `network` + `slug` are missing.
    - `:uid` (String.t): The UID of the listing that was returned at the time of creation. It persists over time and across accounts. This field is required if `jobId` and `network` + `slug` are missing.
    - `:"fields[]"` ([String.t]): List of review fields to be returned
    - `:hasPhotos` (boolean()): Only available if `monitoring` is enabled for the review job. If requested, only reviews with photos are returned. If set to false, only reviews without photos are returned. To include all reviews regardless of whether they have photos or not, omit this option.
    - `:hasReplies` (boolean()): Only available if `monitoring` is enabled for the review job. If requested, only reviews with replies are returned. If set to false, only reviews without replies are returned. To include all reviews regardless of whether they have replies or not, omit this option.
    - `:hasEdits` (boolean()): Only available if `monitoring` is enabled for the review job. If requested, only reviews with edits are returned. Edits can be reported by the review platform, like with Yelp, or have been detected by our engines. If set to false, only reviews without edits are returned. To include all reviews regardless of whether they have edits or not, omit this option.
    - `:isHidden` (boolean()): Only available if `monitoring` is enabled for the review job. If true, only reviews that are kept hidden on the review platform are included, e.g. non-recommended reviews on Yelp. If false, only visible reviews are returned.
    - `:isRecommended` (boolean()): Only available if `monitoring` is enabled for the review job. If true, reviews considered as positive recommendation (recommended) are returned. If false, reviews considered as negative recommendation (not recommended) are included.
    - `:isDeleted` (boolean()): Only available if `monitoring` is enabled for the review job. If true, only deleted reviews will be returned. This requires `includeDeleted` to be also set to `true`. If false, this will have the same effect if `includeDeleted` was not set or is set to `false` and will only return non-deleted reviews.
    - `:maxRating` (float()): Only available if `monitoring` is enabled for the review job. Limits the highest rating of the returned reviews.
    - `:minRating` (float()): Only available if `monitoring` is enabled for the review job. Limits the lowest rating of the returned reviews.
    - `:postedBefore` (Date.t): Only available if `monitoring` is enabled for the review job. Setting this parameter restricts the result to contain only reviews that were posted before the specified date. The input format is UNIX timestamp.
    - `:postedAfter` (Date.t): Only available if `monitoring` is enabled for the review job. Setting this parameter restricts the result to contain only reviews that were posted after the specified date. The input format is UNIX timestamp.
    - `:language` (String.t): Only available if `monitoring` is enabled for the review job. Return only reviews which language matches the given string.
    - `:includeDeleted` (boolean()): Only available if `monitoring` is enabled for the review job. If requested, the result will include reviews that are detected by our engines as deleted, i.e. reviews that were live at some point then detected missing.
    - `:sortBy` (String.t): Only available if `monitoring` is enabled for the review job. Indicates the desired sorting attribute.
    - `:sortDirection` (String.t): Only available if `monitoring` is enabled for the review job. Indicates the desired sorting direction.
    - `:limit` (integer()): Indicates the maximum number of reviews to be returned. If you do not set a `limit` and you do not change the default filters and the list of fields then all the reviews will be returned regardless of the size. In the event you change the filters and/or the list of fields and omit the `limit` then the default limit will be applied.
    - `:offset` (integer()): Helps with pagination. It indicates the offset to be applied to the set of reviews.

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.GetReviewJob200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec get_review_job(Tesla.Env.client, keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetReviewJob200Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName400Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetReviewJob404Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetReviewJob206Response.t} | {:error, Tesla.Env.t}
  def get_review_job(connection, opts \\ []) do
    optional_params = %{
      :network => :query,
      :slug => :query,
      :jobId => :query,
      :uid => :query,
      :"fields[]" => :query,
      :hasPhotos => :query,
      :hasReplies => :query,
      :hasEdits => :query,
      :isHidden => :query,
      :isRecommended => :query,
      :isDeleted => :query,
      :maxRating => :query,
      :minRating => :query,
      :postedBefore => :query,
      :postedAfter => :query,
      :language => :query,
      :includeDeleted => :query,
      :sortBy => :query,
      :sortDirection => :query,
      :limit => :query,
      :offset => :query
    }

    request =
      %{}
      |> method(:get)
      |> url("/reviews")
      |> add_optional_params(optional_params, opts)
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.GetReviewJob200Response},
      {206, WelcomeToZembraAPIDocumentation.Model.GetReviewJob206Response},
      {400, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName400Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response},
      {404, WelcomeToZembraAPIDocumentation.Model.GetReviewJob404Response}
    ])
  end

  @doc """
  Get Review Jobs List
  Returns the list of review jobs of the account. The result includes details about the job like requested time, internal ID, etc. The maximum number of returned jobs is 100 but you may use the `limit` and `offset` parameters for pagination.

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `opts` (keyword): Optional parameters
    - `:network` (ReviewNetwork): Returns jobs only from the requested network.
    - `:slug` (String.t): Filter results to only jobs with similar slug. Please see the description of `slug` in section **[GET] /listing/{network}**.
    - `:monitoring` (Monitoring): 
    - `:internalId` (String.t): Filter results to only jobs with similar internal ID. This is the ID you set on the job that identifies it with your application. Please see the description of `internalId` in section **[POST] /reviews**.
    - `:all` (boolean()): By default, the API will return the active and unexpired records. Setting this input to `true` will allow returning deleted and expired records.
    - `:limit` (integer()): Maximum number of jobs to be returned. At most 100 jobs will be returned even if this parameter is set to a higher value.
    - `:offset` (integer()): Helps with pagination. It controls the offset to be applied to the set of jobs.
    - `:sortBy` (String.t): Indicates the desired sorting attribute.
    - `:sortDirection` (String.t): Indicates the desired sorting direction.

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.GetReviewJobs200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec get_review_jobs(Tesla.Env.client, keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetListingDetails400Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetReviewJobs200Response.t} | {:error, Tesla.Env.t}
  def get_review_jobs(connection, opts \\ []) do
    optional_params = %{
      :network => :query,
      :slug => :query,
      :monitoring => :query,
      :internalId => :query,
      :all => :query,
      :limit => :query,
      :offset => :query,
      :sortBy => :query,
      :sortDirection => :query
    }

    request =
      %{}
      |> method(:get)
      |> url("/reviews/jobs")
      |> add_optional_params(optional_params, opts)
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.GetReviewJobs200Response},
      {400, WelcomeToZembraAPIDocumentation.Model.GetListingDetails400Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response}
    ])
  end

  @doc """
  Update Review Job
  Applies changes to an existing and active review job.

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `update_review_job_request` (UpdateReviewJobRequest): 
  - `opts` (keyword): Optional parameters

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.UpdateReviewJob200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec update_review_job(Tesla.Env.client, WelcomeToZembraAPIDocumentation.Model.UpdateReviewJobRequest.t, keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.UpdateReviewJob200Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.FetchReviews404Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.DeleteReviewJob400Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response.t} | {:error, Tesla.Env.t}
  def update_review_job(connection, update_review_job_request, _opts \\ []) do
    request =
      %{}
      |> method(:patch)
      |> url("/reviews")
      |> add_param(:body, :body, update_review_job_request)
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.UpdateReviewJob200Response},
      {400, WelcomeToZembraAPIDocumentation.Model.DeleteReviewJob400Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response},
      {403, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName403Response},
      {404, WelcomeToZembraAPIDocumentation.Model.FetchReviews404Response}
    ])
  end
end
