# NOTE: This file is auto generated by OpenAPI Generator 7.13.0-SNAPSHOT (https://openapi-generator.tech).
# Do not edit this file manually.

defmodule WelcomeToZembraAPIDocumentation.Api.Status do
  @moduledoc """
  API calls for all endpoints tagged `Status`.
  """

  alias WelcomeToZembraAPIDocumentation.Connection
  import WelcomeToZembraAPIDocumentation.RequestBuilder

  @doc """
  Get Platforms Status
  Due to relatively recent changes introduced by the originating websites, some platforms may experience down time while our team is actively working on rolling out required patches. In the meantime, you might be interested in programmatically checking the status of our supported networks. <br><br>For more details, please visit [https://status.zembra.io/](https://status.zembra.io/) 

  ### Parameters

  - `connection` (WelcomeToZembraAPIDocumentation.Connection): Connection to server
  - `opts` (keyword): Optional parameters

  ### Returns

  - `{:ok, WelcomeToZembraAPIDocumentation.Model.GetPlatformStatus200Response.t}` on success
  - `{:error, Tesla.Env.t}` on failure
  """
  @spec get_platform_status(Tesla.Env.client, keyword()) :: {:ok, WelcomeToZembraAPIDocumentation.Model.GetPlatformStatus200Response.t} | {:ok, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response.t} | {:error, Tesla.Env.t}
  def get_platform_status(connection, _opts \\ []) do
    request =
      %{}
      |> method(:get)
      |> url("/status")
      |> Enum.into([])

    connection
    |> Connection.request(request)
    |> evaluate_response([
      {200, WelcomeToZembraAPIDocumentation.Model.GetPlatformStatus200Response},
      {401, WelcomeToZembraAPIDocumentation.Model.GetPropertyDetailsByName401Response}
    ])
  end
end
